#pragma once

#include "resource.h"
#include <atlctrls.h>
#include <atldlgs.h>
#include <stdio.h>

class CMemo : public CDialogImpl<CMemo>, public CMessageFilter {
public:
	enum { IDD = IDD_DIALOG_MAIN }; //_CAO\[XɃEBhE쐬
	enum { s_cxyBorder = 2 };

	CEdit 	m_Edit;


	BOOL PreTranslateMessage(MSG * /*pMsg*/)
	{
		return FALSE;
	}


	//bZ[W}bv
	BEGIN_MSG_MAP(CMemo)
		COMMAND_ID_HANDLER(ID_MEMO_FILE_NEW , OnFileNew )
		COMMAND_ID_HANDLER(ID_MEMO_FILE_OPEN, OnFileOpen)
		COMMAND_ID_HANDLER(ID_MEMO_FILE_SAVE, OnFileSave)
		MESSAGE_HANDLER(WM_SIZE		 , OnSize)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	END_MSG_MAP()


	//_CAO쐬
	LRESULT OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL & /*bHandled*/)
	{
		m_Edit = GetDlgItem(IDC_EDIT);
		return 0;
	}


	//EBhȆ傫ύX悤vꂽ
	LRESULT OnSize(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL & /*bHandled*/)
	{
		int   Width  = LOWORD(lParam);
		int   Height = HIWORD(lParam);

		CEdit edit	 = GetDlgItem(IDC_EDIT);

		edit.MoveWindow( s_cxyBorder, s_cxyBorder, Width - s_cxyBorder, Height - s_cxyBorder, TRUE);
		return 0;
	}


	//VK쐬
	LRESULT OnFileNew(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		ResetProcedure();
		return 0;
	}


	//J
	LRESULT OnFileOpen(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		if ( !ResetProcedure() )
			return 0;

		CFileDialog fdlg(TRUE, NULL, NULL, OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,
						 _T("eLXgt@C(*.txt)\0*.txt\0SẴt@C(*.*)\0*.*\0"), m_hWnd);

		if (fdlg.DoModal() == IDOK) {
			ReadFromFile(fdlg.m_szFileName);
		}

		return 0;
	}


	//Oĕۑ
	LRESULT OnFileSave(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL & /*bHandled*/)
	{
		CFileDialog fdlg(FALSE, _T("txt"), NULL, OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY,
						 _T("eLXgt@C(*.txt)\0*.txt\0SẴt@C(*.*)\0*.*\0"), m_hWnd);

		if (fdlg.DoModal() == IDOK) {
			SaveToFile(fdlg.m_szFileName);
		}

		return 0;
	}


	//߂l IDYES - ۑKvƂ
	//		 IDNO  - ۑȂ
	//		 IDCANCEL - 
	int _QueryResetData()
	{
		if ( m_Edit.GetModify() ) {
			return MessageBox(_T("eύXĂ܂BύXۑ܂H"), _T("MemovOC"), MB_YESNOCANCEL);
		}

		return IDNO;
	}


	//GfBbgRg[̏
	void _ResetData()
	{
		m_Edit.SetWindowText( _T("") );
		m_Edit.EmptyUndoBuffer();
		m_Edit.SetModify(FALSE);
	}


	//VK쐬EJ̎葱
	BOOL ResetProcedure()
	{
		int nRet = _QueryResetData();

		if (nRet == IDCANCEL) {
			return FALSE;
		} else if (nRet == IDYES) {
			CFileDialog fdlg(FALSE, _T("txt"), NULL, OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY,
							 _T("eLXgt@C(*.txt)\0*.txt\0SẴt@C(*.*)\0*.*\0"), m_hWnd);

			if (fdlg.DoModal() == IDOK) {
				SaveToFile(fdlg.m_szFileName);
			} else {
				return FALSE;
			}
		}

		_ResetData();
		return TRUE;
	}


	//t@C̓ǂݍ݁@32KB܂
	void ReadFromFile(LPCTSTR lpstrFile)
	{
		int   	bufsize = 2 << 15;
		TCHAR*	buf	   	= new char[bufsize + 1];		//+++ +1ǉ.(readcout==bufsize̎AI[\0̂߂͈̃͊OɂȂ̂ŁA\0p̃m.)
		int    	readcount;

		FILE*	fp	   	= fopen( lpstrFile, _T("rb") );

		if (fp == NULL) {
			MessageBox( _T("t@C̓ǂݍ݂Ɏs܂B") );
			goto EXIT;
		}

		//Kɓǂݍ݂܂
		readcount	   = fread(buf, 1, bufsize, fp);
		buf[readcount] = '\0';

		//ʓ|Ȃ̂UNICODEƂlȂ
		if ( !m_Edit.SetWindowText(buf) ) {
			MessageBox( _T("t@C̓ǂݍ݂Ɏs܂B") );
			goto EXIT;
		}

	  EXIT:
		if (fp)
			fclose(fp);

		if (buf)
			delete[] buf;
	}


	//t@Cɕۑ
	BOOL SaveToFile(LPCTSTR lpstrFile)
	{
		BOOL		 bRet	= TRUE;
		unsigned int length = m_Edit.GetWindowTextLength();

		if (length == 0)
			return FALSE;

		char *		 buf	= new char[length + 1];
		FILE *		 fp 	= fopen( lpstrFile, _T("wb") );

		if (fp == NULL) {
			MessageBox( _T("t@C̕ۑɎs܂B") );
			bRet = FALSE;
			goto EXIT;
		}

		m_Edit.GetWindowText(buf, length + 1);

		if (fwrite(buf, 1, length, fp) != length) {
			MessageBox( _T("t@C̕ۑɎs܂B") );
			bRet = FALSE;
			goto EXIT;
		}

	  EXIT:
		if (fp)
			fclose(fp);

		if (buf)
			delete[] buf;

		return bRet;
	}
};
